function chain (tconstant,ee,L)

poolNumber=64;
p=parpool('Threads')
subrange=20;
opts = parforOptions(p,'RangePartitionMethod','fixed','SubrangeSize',subrange)
repeat=poolNumber*subrange;

len=L

up=[0 1
    0 0];
down=[0 0
      1 0];

spiny=[0 -1i
       1i 0 ];

spinz=[1 0
      0 -1];

number=[1 0;
       0 0];

Hde=0;
for clen=1:len-1
        Hde= Hde + 1j*site(up,clen,len)*site(down,clen+1,len);
end
Hde= Hde + 1j*site(up,len,len)*site(down,1,len);
Hde=Hde+Hde';
Hde=sparse(Hde);
spinz_list=cell(1,len);
for i=1:len
spinz_list{i}=site(spinz,i,len);
end
spiny_list=cell(1,len);
for i=1:len
spiny_list{i}=site(spiny,i,len);
end
number_list=cell(1,len);
for i=1:len
number_list{i}=site(number,i,len);
end
halfP=1;
for i=1:len/2
    halfP=halfP*spinz_list{i};
end
%in sparse matrix

lambda=tconstant/100;
eta=ee; %efficiency
gamma_list=logspace(log10(0.05),log10(4),5);

puri=cell(1,length(gamma_list));
pari=cell(1,length(gamma_list));
negat=cell(1,length(gamma_list));
for cg=1:length(gamma_list)

gamma=gamma_list(cg);
disp([gamma,lambda,eta])

time=80;
if gamma>3
    time=50;
end
dt=min( [0.05,0.05/gamma,0.05/lambda] );
timestep=round(time/dt);

store_amount=timestep;
puri_evo=zeros(store_amount,repeat);
pari_evo=zeros(store_amount,repeat);
negat_evo=zeros(store_amount,repeat);

state=zeros(2^len,1);
state(1:2)=1;
state=state/(state'*state)^0.5;


parfor (cr=1:repeat) %amount of repeat
rho=sparse(state*state');
temp2=zeros(1,store_amount);
temp3=zeros(1,store_amount);
temp4=zeros(1,store_amount);
    for l=1:timestep
        if l<2
            rho=state*state';
        end
                %unitary
                noise_rand=(gamma/dt)^0.5*randn(len,1);
                Hnoise=0;
                for i=1:len
                    Hnoise=Hnoise+ spiny_list{i}*noise_rand(i);
                end
                unitary=(eye(2^len)-1i/2*(Hde+Hnoise)*dt)/(eye(2^len)+ 1i/2*(Hde+Hnoise)*dt);
                % measurement
                mea_rand= (eta*lambda*dt)^0.5*randn(len,1);
                spinz_ev_list=zeros(len,1);
                for i=1:len
                    spinz_ev_list(i)=trace(rho*spinz_list{i});
                end
                BigM1=0;
                for i=1:len
                    BigM1=BigM1+spinz_list{i}*mea_rand(i);
                end
                BigM2=0;
                for i=1:len
                    BigM2=BigM2-1/2*lambda*spinz_list{i}^2*(1+eta)*dt + eta*lambda*spinz_list{i}*2*spinz_ev_list(i)*dt+spinz_list{i}*mea_rand(i);
                end
                BigM= unitary +BigM2 +BigM1*BigM1/2; %due to inefficiency, the update cannot be done by simulating the master equation directly. 
                                                     % SEE PHYSICAL REVIEW A 91, 012118 (2015)
                inbetween=0;
                for i=1:len
                    inbetween=inbetween+ (1-eta) * lambda * dt * spinz_list{i}*rho*spinz_list{i};
                end
                rho1= BigM*rho*BigM' + inbetween;
		        rho1=real(rho1/trace(rho1))
                TR_rho=partial_TR(rho1,len/2,len);% partial tracing half system
                tracedrho=half_rho(rho,len);%reduced half-system density matrix
                temp2(l)=log(trace(sqrtm(TR_rho*TR_rho') ) ); %logarithmic negativity 
                temp3(l)=trace(halfP*rho)^2;
                temp4(l)=trace(tracedrho^2);
                rho=rho1;
    end
    puri_evo(:,cr)=temp4;
    negat_evo(:,cr)=temp2;
    pari_evo(:,cr)=temp3;
end
disp('finish')
puri{cg}=mean(puri_evo,2);
pari{cg}=mean(pari_evo,2);
negat{cg}=mean(negat_evo,2);
end
fullMatFileName = fullfile("chain_lambda"+num2str(lambda) );
save("/mmfs1/home/users/leungcy2/non_mono/chain/eta"+num2str(ee)+"/L"+num2str(L)+"/"+fullMatFileName+".mat",'pari','negat','puri','gamma_list','lambda','eta')
end

function P=anticomm(A,B)
P=A*B+B*A;
end

function P=comm(A,B)
P=A*B-B*A;
end

function PTR_rho=partial_TR(rho,site,len)
rho_cell=mat2cell(rho,repelem(2^(len-site),2^site),repelem(2^(len-site),2^site ) );
temp=cell(2^(len-site),2^site);
for i=1:2^site
for j=1:2^site
temp{i,j}=(-1)^site*rho_cell{j,i};
end
end
PTR_rho=cell2mat(temp);
end

function P=site(spin,site_index,length)
P=sparse(spin);
for i=1:length
    if i<site_index
        P=kron( speye(2) , P );
    elseif i>site_index
        P=kron( P , speye(2) );
    end
end
P=sparse(P);
end

function red_rho=half_rho(rho,len)%reduced half-system density matrix
rho_cell=mat2cell(rho,repelem(2^(len/2),2^(len/2)),repelem(2^(len/2),2^(len/2) ) );
red_rho=zeros(2^(len/2),2^(len/2) );
for i=1:2^(len/2)
for j=1:2^(len/2)
red_rho(i,j)=trace(rho_cell{i,j});
end
end

end
