%%
clear
%%%%%%%%%% This section prodcues a plot of the trajectory-averaged time
%%%%%%%%%% evolution of a chosen quantity. The plot is not included in the
%%%%%%%%%% paper, and is here for references.
load('chain_lambda3.mat') %click into one of the subfolder containing the data `.mat' file to load and display the graph
length(negat{1,1}) %or pari for half-system parity
figure;hold on
for i=1:4
plot(linspace(0,90,length(negat{1,i})),negat{1,i},'-')
end
%% Length scaling
clear
%%%%%%%%%% This section prodcues the length scaling plots in Fig.4 and
%%%%%%%%%% Fig.5, i.e. (a)-(d).
L=[10,4,6,8];
gamma_number=3; % !!!! change this number to access other values of noise strength. See `gamma_list' for the list of noise strength
D = 'D:\dropbox\Dropbox\Chun PhD\non mono paper\all_relevant_data\chain\results\eta1'; %change accordingly to the directory of the folder containing the concurrence data
S = dir(fullfile(D,'*'));
N = setdiff({S([S.isdir]).name},{'.','..'}); % list of subfolders of D.
iwant2 = cell(numel(N),1) ;  % to save output 
for ii=1:numel(N)
T = dir(fullfile(D,N{ii},'*.mat')); % improve by specifying the file extension.
C = {T(~[T.isdir]).name};
numel(C)
for jj = 1:1:numel(C)
    F = fullfile(D,N{ii},C{jj});
    load(F)
    iwant1{jj}=lambda;
    temp=negat{1,gamma_number};
    iwant2{ii,jj}=mean(temp(end-50:end));
end
end
[L,sortid1]=sort(L);
lambda_list=cell2mat(iwant1);
[lambda_list,sortid2]=sort(lambda_list);
figure;hold on
cmap = flip(winter(6),1); % Use this line to change the colour scheme.
set(gca(),'ColorOrder',cmap)
toplot=cell2mat(iwant2);
toplot=toplot(sortid1,sortid2);
plot(L,toplot(:,1:2:11),'-o','LineWidth',3,'MarkerSize',10) % change the number `2' to adjust how many lambda'a value you wish to include in your plot
ylabel('$\overline{P_{1/2}}$','Interpreter','Latex')
xlabel('$L$','Interpreter','Latex')
ylim([0 1])
yticks([0.3 0.6])
set(gca,'TickLabelInterpreter','latex')
xticks([4 6 8 10])
% yticks([0.3 0.6 0.9])
lambda_list=lambda_list(1:1:11);
lambda_number=length(lambda_list);
Legend=cell(lambda_number,1);
for iter=1:lambda_number
  Legend{iter}=strcat('\lambda=', num2str(lambda_list(iter)) );
end
legend box off
legend(Legend,'Location','northeast')
title("$\Gamma$=" + num2str(round(gamma_list(gamma_number)*100)/100) ,'interpreter','latex')
fontsize(gcf,55,"points")
%% eta=1
%%%%% critical measurement strength extracted from the plot. This is for
%%%%% measuremnt efficiency η = 1.
figure;hold on
lcn=[1.2,2.4,3.6,4.8];
lcp=[1.2,2.4,3.6,4.8];
max_err=[0.2,0.2,0.2,0.2];
min_err=[0.2,0.2,0.2,0.2];
errorbar(gamma_list,lcn,min_err,max_err,'-o','MarkerSize',15,'LineWidth',3,'Color',"#77AC30")
max_err=[0.2,0.2,0.2,0.2];
min_err=[0.2,0.2,0.2,0.2];
errorbar(gamma_list,lcp,min_err,max_err,'--square','MarkerSize',15,'LineWidth',3,'Color',"#77AC30")
xticks([0.05 0.1 0.15 0.2])
yticks([1.2 2.4 3.6 4.8])
ylabel('$\lambda_{\mathrm{crit}}$','Interpreter','Latex')
xlabel('$\Gamma$','Interpreter','Latex')
set(gca,'TickLabelInterpreter','latex')
Legend={'$\overline{\epsilon_{1/2}}$','$\overline{P_{1/2}}$'};
legend box off
legend(Legend,'Location','northwest','Interpreter','Latex')
fontsize(gcf,55,"points")
%% eta=0.8
%%%%% critical measurement strength extracted from the plot. This is for
%%%%% measuremnt efficiency η = 0.8
figure;hold on
lcn=[1.2,2.4,3.6];
lcp=[1.2,2.8,4.4];
max_err=[0.2,0.2,0.2];
min_err=[0.2,0.2,0.2];
errorbar(gamma_list(1:3),lcn,min_err,max_err,'-o','MarkerSize',15,'LineWidth',3,'Color',"#7E2F8E")
max_err=[0.2,0.2,0.2];
min_err=[0.2,0.2,0.2];
errorbar(gamma_list(1:3),lcp,min_err,max_err,'--square','MarkerSize',15,'LineWidth',3,'Color',"#7E2F8E")
% eta=0.4
lcn=[0.1,0.1,0.1];
lcp=[1.2,4,6.8];
max_err=[0.1,0.1,0.1];
min_err=[0.1,0.1,0.1];
errorbar(gamma_list(1:3),lcn,min_err,max_err,'-o','MarkerSize',15,'LineWidth',3,'Color',"#EDB120")
max_err=[0.2,0.2,0.2];
min_err=[0.2,0.2,0.2];
errorbar(gamma_list(1:3),lcp,min_err,max_err,'--square','MarkerSize',15,'LineWidth',3,'Color',"#EDB120")
xticks([0.05 0.1 0.15 0.2])
yticks([1.2 2.4 3.6 4.8])
ylabel('$\lambda_{\mathrm{crit}}$','Interpreter','Latex')
xlabel('$\Gamma$','Interpreter','Latex')
set(gca,'TickLabelInterpreter','latex')
xlim([0.05 0.15])
ylim([0 5])
fontsize(gcf,55,"points")
%%
x = 1:10:100;
y = [20 30 45 40 60 65 80 75 95 90];
err = 8*ones(size(y));
errorbar(x,y,err)