%%
clear
%%%%%%%%% In this section, we are fixing the measurement strength λ, and
%%%%%%%%% plotting the desired quantity against changing noise strength Γ
%%%%%%%%% over a range of measurement efficiency η. To be specific,
%%%%%%%%% the data is available for η = [0, 0.2, 0.4, 0.6, 0.8, 1]. The
%%%%%%%%% corresponding set of graphs are Fig. 3 in the main text.
spiny=[0 -1i
       1i 0 ];
%%%%%%%%%%%%
fix_lambda=0.05;
%%%%%%%%%%%%
D = 'D:\dropbox\Dropbox\Chun PhD\non mono paper\all_relevant_data\two_qubits_data'; %change accordingly to the directory of the folder containing the concurrence data
S = dir(fullfile(D,'*'));
N = setdiff({S([S.isdir]).name},{'.','..'}) % list of subfolders of D.
kk=1;
for ii=1:numel(N)
    if contains(N{ii},'eta')==1 %only pick up subfolders with their names containing `eta'
        disp(N{ii})
        T = dir(fullfile(D,N{ii},'*.mat')); % improve by specifying the file extension
        C = {T(~[T.isdir]).name};
        iwant1 = cell(numel(C),1) ;  % to save output
        iwant2 = cell(numel(C),1) ;  % to save output 
        for jj = 1:numel(C)
            F = fullfile(D,N{ii},C{jj});
            load(F)
            if lambda==fix_lambda
                All_folder_cell1{kk}=N{ii};
                All_folder_cell2{kk}=concur; % change the variable `concur' to the desired quantity,
                                             % e.g. concur for concurrence or pari for half-system parity variance
            end
        end
        kk=kk+1;
    end
end
how_thicc=6;
figure;hold on
for k=1:numel(All_folder_cell1)
for i=1:length(gamma_list)
temp=real(All_folder_cell2{k}{i}); % put - if pair correlator
concur_plot(k,i)=mean(temp(end-200:end));
end
p(k,:)=concur_plot(k,:);
eta_temp(k)=sscanf(All_folder_cell1{k},'eta%f');
end
[eta_temp,sortid]=sort(eta_temp);
p=p(sortid,:);
for k=1:1:numel(All_folder_cell1)
plot(gamma_list,p(k,:),'--','LineWidth',how_thicc)
end

% for k=7:7:21
% plot(gamma_list,p(k,:),'--','LineWidth',how_thicc)
% lambda_temp(j)=lambda_temp(k);
% j=j+1;
% end

set(gca,'Xscale','log')
fontsize(gcf,17.23/11*50,"points")
box on
axis tight
eta_number=length(eta_temp);
Legend=cell(eta_number,1);
for iter=1:eta_number
  Legend{iter}=strcat('\eta=', num2str(round(eta_temp(iter),3)));
end
% legend(Legend,'Location','northeast')
% legend boxoff
xlabel('$\Gamma$','Interpreter','Latex')
ylabel('$\overline{\epsilon_{1/2}}$','Interpreter','Latex')
title("$\lambda=$"+num2str(fix_lambda),'Interpreter','Latex')
ylim([0 0.4])
yticks([0 0.3 0.6])
xticks([0.01 0.1 1 10])
leftcolors = [0 0 1; 0 0.2 1; 0 0.4 1; 0 0.6 1; 0 0.8 1; 0 1 1]; % set second thrid column to zero if want red brown progression
colororder(leftcolors)
%%%%%%%%%
for k=1:1:numel(All_folder_cell1)
if k>1
[mv,mi]=max(p(k,2:end));
if mi>2
plot(gamma_list(mi+1),mv,'ok','MarkerFaceColor','k','MarkerSize',16,'HandleVisibility','off') 
end
end
end
%%
%%%%%%%%% In this section, we are plotting the desired quantity against
%%%%%%%%% changing noise strength Γ, for fixed measurement efficiency η.
%%%%%%%%% The corresponding sets of graphs are Fig. 2(b)-(d).
clear
spiny=[0 -1i
       1i 0 ];
fix_lambda=0.5;
D = 'D:\dropbox\Dropbox\Chun PhD\non mono paper\all_relevant_data\two_qubits_data\large_g_and_large_lambda\eta1';  %change accordingly to the directory of the folder containing the concurrence data
S = dir(fullfile(D,'*.mat'))
C = {S(~[S.isdir]).name};
iwant1 = cell(numel(C),1) ;  % to save output
iwant2 = cell(numel(C),1) ;  % to save output 
for jj = 1:numel(C)
    F = fullfile(D,C{jj});
    load(F)
    iwant1{jj}=lambda;
    iwant2{jj}=pari; % change the variable `pari' to the desired quantity,
                     % e.g. concur for concurrence or pari for half-system parity variance
end

how_thicc=5;
figure;hold on
for k=1:numel(iwant2)
for i=1:length(gamma_list)
temp=real(iwant2{k}{i}); % put - if pair correlator
concur_plot(k,i)=mean(temp(end-350:end));
end
p(k,:)=concur_plot(k,:);
lambda_temp(k)=iwant1{k};
end
[lambda_temp,sortid]=sort(lambda_temp);
p=p(sortid,:);
j=1;
for k=1:1:2
plot(gamma_list,p(k,:),'--','LineWidth',how_thicc)
lambda_temp1(j)=lambda_temp(k);
j=j+1;
end
% for k=7:7:21
% plot(gamma_list,p(k,:),'--','LineWidth',how_thicc)
% lambda_temp(j)=lambda_temp(k);
% j=j+1;
% end

set(gca,'Xscale','log')
fontsize(gcf,50,"points")
box on
axis tight
lambda_number=length(lambda_temp1);
Legend=cell(lambda_number,1);
for iter=1:lambda_number
  Legend{iter}=strcat('\lambda=', num2str(round(lambda_temp1(iter),3)));
end
legend(Legend,'Location','northeast')
legend boxoff
xlabel('$\Gamma$','Interpreter','Latex')
ylabel('$\overline{\epsilon_{1/2}}$','Interpreter','Latex')
title("$\eta=$"+num2str(eta),'Interpreter','Latex')
ylim([0 0.8])
yticks([0 0.2 0.4])
temp=length(1:1:4);
leftcolors = cat(2,cat(2,linspace(0,1,temp)',zeros(temp,1)),zeros(temp,1));
colororder(leftcolors)
%%%%%%%%%%
for k=1:1:2
if k>1 && k<20
[mv,mi]=min(p(k,2:end));
if mi>2
plot(gamma_list(1+mi),mv,'ob','MarkerFaceColor','b','MarkerSize',12,'HandleVisibility','off')
end
end
end
%%
%%%%%%%% In this section, we are plotting the 2D colour plot of concurrence
%%%%%%%% against measurement strength λ (vertical axis) and noise strength
%%%%%%%% Γ (horizontal axis). This corresponds to Fig. 2(a). 
%%%%%%%% Please RUN the previous section first to load the data.
[X,Y] = ndgrid(gamma_list,lambda_temp);
pcolor(X,Y,real(p)')
set(gca,'Xscale','log')
set(gca,'Yscale','linear')
set (gca,'YDir','reverse')
c=colorbar('westoutside')
c.Label.String = '$\overline{\mathcal{C}}$'
c.Label.Interpreter = 'latex'
% Create colormaps
blues = [
    linspace(0, 1, 100); % red and green values are changing from 0 to 1
    linspace(0, 1, 100); % in order to create a blue-to-white transition
    linspace(0, 1, 100);
    ]';

reds = [
    linspace(1, 1, 100);
    linspace(1, 0, 100); % green and blue values are changing from 1 to 0
    linspace(1, 0, 100); % in order to create a white-to-red transition  
    ]';

custom_map = [blues; reds]; % this one is blues-white-white-red

colormap(custom_map);
fontsize(gcf,55,"points")
yticks([0 0.5 1])
ylabel('$\lambda$','Interpreter','Latex')
xlabel('$\Gamma$','Interpreter','Latex')
%%
clear
%%%%%%%%%% This section prodcues a plot of the trajectory-averaged time
%%%%%%%%%% evolution of a chosen quantity. The plot is not included in the
%%%%%%%%%% paper, and is here for references.
load('2_qubits_diffusioneta1lambda0.15.mat') %click into one of the subfolder containing the data `.mat' file to load and display the graph
how_thicc=2;
figure;hold on
j=1;
for i=1:1:length(gamma_list)
if max([gamma_list(i),lambda])<=0.02
time=80;
elseif max([gamma_list(i),lambda])>=1
time=30;
else
time=50;
end
p(j,:)=plot(linspace(0,time,length(puri{i})),concur{i},'-','LineWidth',how_thicc); % change the variable `concur' to the desired quantity, 
                                                                                   % e.g. pari for half-system parity.
gamma_temp(j)=gamma_list(i);
j=j+1;
end
fontsize(gcf,55,"points")
box on
axis tight
gamma_number=length(gamma_temp);
Legend=cell(gamma_number,1);
for iter=1:gamma_number
  Legend{iter}=strcat('\Gamma=', num2str(round(gamma_temp(iter),3)));
end
legend(Legend,'Location','northeast')
legend boxoff
xlabel('$t$','Interpreter','Latex')
ylabel('$\overline{\mathcal{C}}$','Interpreter','Latex')
xlim([0 30])
% ylim([0 1])