function Twoqubit_HEC (tconstant,ee)

len=2;

up=[0 1
    0 0];
down=[0 0
      1 0];
Hde=1i*kron( up , down ) - 1i*kron( down , up );

spiny=[0 -1i
       1i 0 ];
H_noise1=kron(spiny,eye(2));
H_noise2=kron(eye(2),spiny);

number=[1 0;
       0 -1];
m1=kron(number,eye(2));
m2=kron(eye(2),number);

lambda=tconstant/100;
eta=ee;
gamma_list=logspace(-2,1,21);


concur=cell(1,length(gamma_list)); %amount of repeat
corre=cell(1,length(gamma_list));
pari=cell(1,length(gamma_list));
puri=cell(1,length(gamma_list));
negat=cell(1,length(gamma_list));

poolNumber=4; %number of CPU in node
% p=parpool(poolNumber)
subrange=250;
% opts = parforOptions(p,'RangePartitionMethod','fixed','SubrangeSize',subrange)
repeat=poolNumber*subrange;


for cg=1:length(gamma_list)

gamma=gamma_list(cg);
disp([gamma,lambda,eta])

if max([gamma,lambda])<=0.02
time=80;
elseif max([gamma,lambda])>=1
time=30;
else
time=50;
end
dt=min( [0.05,0.05/gamma,0.05/lambda] );
timestep=round(time/dt);

store_amount=timestep;
concur_evo=zeros(store_amount,repeat); %amount of repeat
corre_evo=zeros(store_amount,repeat);
pari_evo=zeros(store_amount,repeat);
puri_evo=zeros(store_amount,repeat);
negat_evo=zeros(store_amount,repeat);

state=ones(2^len,1);
state=state/(state'*state)^0.5;


parfor (cr=1:repeat) %amount of repeat
rho=state*state';
temp=zeros(1,store_amount);
temp1=zeros(4,4,store_amount);
temp2=zeros(1,store_amount);
temp3=zeros(1,store_amount);
temp4=zeros(1,store_amount);
temp5=zeros(1,store_amount);
    for l=1:timestep
        if l<2
            rho=state*state';
        end
                noise1_rand= (gamma/dt)^0.5*randn;
                noise2_rand= (gamma/dt)^0.5*randn;
                mea_rand1= dt^0.5*randn;
                mea_rand2= dt^0.5*randn;
                m1ev=trace(m1*rho);
                m2ev=trace(m2*rho);
                unitary=(eye(4)-1i/2*(Hde + ( H_noise1*noise1_rand + H_noise2*noise2_rand ) )*dt)/(eye(4)+ 1i/2*(Hde + ( H_noise1*noise1_rand + H_noise2*noise2_rand ) )*dt);
                BigM= unitary - 1/2*lambda*( m1*m1 + m2*m2 ) *dt + eta^0.5*m1*lambda^0.5 * ( eta^0.5*2*m1ev*lambda^0.5*dt + mea_rand1 ) + eta^0.5*m2*lambda^0.5 * ( eta^0.5*2*m2ev*lambda^0.5*dt + mea_rand2 ) + ...
                    eta/2 * lambda * ( m1*m1*(mea_rand1^2 - dt ) + m1*m2*(mea_rand1*mea_rand2 ) + m2*m1*(mea_rand1*mea_rand2 ) + m2*m2*(mea_rand2^2 - dt ) );
                rho1= BigM*rho*BigM' + (1-eta) * lambda * dt * ( m1*rho*m1 + m2*rho*m2 );
                rho1=real(rho1/trace(rho1));
                %Concurrence
                rhotilde=kron(spiny,spiny)*conj(rho1)*kron(spiny,spiny);
                eigsquare_list_sort=real( sort( eig(rho1*rhotilde) , 'descend' ) );
                eig_list_sort=( eigsquare_list_sort ).^0.5';
                temp(l)=max( [0,eig_list_sort(1) - eig_list_sort(2) - eig_list_sort(3) - eig_list_sort(4)] );
                TR_rho=partial_TR(rho1,1,2);
                temp2(l)=log(trace(sqrtm(TR_rho*TR_rho') ) );
                temp3(l)=trace(m1*rho)^2;
                temp4(l)=1/4*trace(m1*m2*rho ) - 1/4*trace(m1*rho)*trace(m2*rho)
                reduced=TrX(rho,1,2*ones(1,2));
                temp5(l)=trace(reduced^2);
                temp1(:,:,l+store_amount-timestep)=rho1;
                rho=rho1;
    end
    concur_evo(:,cr)=temp;
    corre_evo(:,cr)=temp4;
    negat_evo(:,cr)=temp2;
    pari_evo(:,cr)=temp3;
    puri_evo(:,cr)=temp5
end
disp('finish')
fullMatFileName = fullfile("2_qubits_diffusion" + "eta"+num2str(ee)+"lambda"+num2str(lambda)+"gamma"+num2str(gamma) );
save("C:/Users/leungcy2/Dropbox/Chun/non mono paper/two qubit gaussian/better results/eta1/"+fullMatFileName+".mat",'pari_evo','negat_evo','corre_evo','concur_evo','puri_evo','gamma_list','lambda','eta','-v7.3')
end
% fullMatFileName = fullfile("2_qubits_diffusion" + "eta"+num2str(ee)+"lambda"+num2str(lambda) );
% save("/mmfs1/home/users/leungcy2/non_mono/Twoqubit/eta"+num2str(ee)+"/"+fullMatFileName+".mat",'pari','negat','corre','concur','puri','gamma_list','lambda','eta','-v7.3')
end

function P=anticomm(A,B)
P=A*B+B*A;
end

function P=comm(A,B)
P=A*B-B*A;
end

function PTR_rho=partial_TR(rho,site,len)
rho_cell=mat2cell(rho,repelem(2^(len-site),2^site),repelem(2^(len-site),2^site ) );
temp=cell(2^(len-site),2^site);
for i=1:2^site
for j=1:2^site
temp{i,j}=(-1)^site*rho_cell{j,i};
end
end
PTR_rho=cell2mat(temp);
end

function x = TrX(p,sys,dim)   

% TRX   Partial trace
% requires: nothing
% author: Toby Cubitt
% license: GPL2
%
%    RHO = TrX(PSI,SYS,DIM) traces out the subsystems specified in
%    vector SYS of state PSI (a state vector or densitry matrix) whose
%    subsystem dimensions are specified by the vector DIM.


%% Copyright (C) 2004-2009 Toby Cubitt
%%
%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License
%% as published by the Free Software Foundation; either version 2
%% of the License, or (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program; if not, write to the Free Software
%% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
%% MA 02110-1301, USA.


% check arguments
if any(sys > length(dim)) || any(sys < 0)
  error('Invalid subsystem in SYS')
end
if (length(dim) == 1 && mod(length(p)/dim,1) ~= 0)...
  || length(p) ~= prod(dim)
  error('Size of state PSI inconsistent with DIM');
end


% remove singleton dimensions
if exist('setdiff')
  % matlab
  sys = setdiff(sys,find(dim == 1));
else
  % octave
  sys = complement(find(dim == 1),sys);
end
dim = dim(find(dim ~= 1));


% calculate systems, dimensions, etc.
n = length(dim);
rdim = dim(end:-1:1);
keep = [1:n];
keep(sys) = [];
dimtrace = prod(dim(sys));
dimkeep = length(p)/dimtrace;


if any(size(p) == 1)
  % state vector
  if size(p,1) == 1
    p = p';
  end
  % reshape state vector to "reverse" ket on traced subsystems into a bra,
  % then take outer product
  perm = n+1-[keep(end:-1:1),sys];
  x = reshape(permute(reshape(p,rdim),perm),[dimkeep,dimtrace]);
  x = x*x';


else
  % density matrix

  % reshape density matrix into tensor with one row and one column index
  % for each subsystem, permute traced subsystem indices to the end,
  % reshape again so that first two indices are row and column
  % multi-indices for kept subsystems and third index is a flattened index
  % for traced subsystems, then sum third index over "diagonal" entries
  perm = n+1-[keep(end:-1:1),keep(end:-1:1)-n,sys,sys-n];
  x = reshape(permute(reshape(p,[rdim,rdim]),perm),...
              [dimkeep,dimkeep,dimtrace^2]);
  x = sum(x(:,:,[1:dimtrace+1:dimtrace^2]),3);

end
end

